## Index

### Classes

- AstBuilder

### Type aliases

- AST_BasicRule
- AST_Neighbor
- AST_Rule
- AST_Tile

### Variables

- RULE_DIRECTION_LIST
- RULE_DIRECTION_SET

### Functions

- cacheSetAndGet
- relativeDirectionToAbsolute
- removeNulls

## Type aliases

### AST_BasicRule

AST_BasicRule: ast.SimpleRule<ast.Bracket<AST_Neighbor>, ast.Command<string>>

- Defined in parser/astBuilder.ts:18

### AST_Neighbor

AST_Neighbor: ast.Neighbor<AST_Tile>

- Defined in parser/astBuilder.ts:17

### AST_Rule

AST_Rule: ast.Rule<ast.RuleGroup<ast.SimpleRule<ast.Bracket<AST_Neighbor>, ast.Command<string>>>, ast.SimpleRule<ast.Bracket<AST_Neighbor>, ast.Command<string>>, ast.Bracket<AST_Neighbor>, ast.Command<string>>

- Defined in parser/astBuilder.ts:19

### AST_Tile

AST_Tile: ast.TileWithModifier<RULE_DIRECTION_WITH_RELATIVE, string>

- Defined in parser/astBuilder.ts:16

## Variables

### Const RULE_DIRECTION_LIST

RULE_DIRECTION_LIST: RULE_DIRECTION[] = [RULE_DIRECTION.UP,RULE_DIRECTION.DOWN,RULE_DIRECTION.LEFT,RULE_DIRECTION.RIGHT]

- Defined in parser/astBuilder.ts:31

### Const RULE_DIRECTION_SET

RULE_DIRECTION_SET: Set<string> = new Set(RULE_DIRECTION_LIST)

- Defined in parser/astBuilder.ts:38

## Functions

### cacheSetAndGet

- cacheSetAndGet<A>(cache: Map<string, A>, obj: A): A

- - Defined in parser/astBuilder.ts:53

  #### Type parameters

  - #### A: ICacheable

  #### Parameters

  - ##### cache: Map<string, A>

  - ##### obj: A

  #### Returns A

### relativeDirectionToAbsolute

- relativeDirectionToAbsolute(currentDirection: RULE_DIRECTION, relativeModifier: RULE_DIRECTION_RELATIVE): UP | DOWN | LEFT | RIGHT

- - Defined in parser/astBuilder.ts:61

  #### Parameters

  - ##### currentDirection: RULE_DIRECTION

  - ##### relativeModifier: RULE_DIRECTION_RELATIVE

  #### Returns UP | DOWN | LEFT | RIGHT

### removeNulls

- removeNulls<T>(ary: Array<T | null>): T[]

- - Defined in parser/astBuilder.ts:40

  #### Type parameters

  - #### T

  #### Parameters

  - ##### ary: Array<T | null>

  #### Returns T[]

Generated using TypeDoc